function convpot(xs,ys,tx,ty,ts,mode)
%CONVPLOT Graphical demonstration of convolution 
%         
%         CONVPLOT(X,H,TX,TH,TS) produces the convolution of the string
%         functions in X and H.  TX and TH are the time durations for both
%         X and H, respectively, and are in the form [Tmin, Tmax].  TS is 
%         the sampling interval and if not specified defaults to the
%         (largest time duration)/50.
%
%         CONVPLOT (with no input arguments) displays this help screen and 
%	  also invokes the example displayed below.
%
%         FOR MATLAB 4.x & 5.x After plot is drawn, you can shift the FOLDED 
%	  (red) function back and forth by locating the cursor on it and then 
%	  depressing and holding down a mouse button. 
%
%         For faster machines, it is recommended that a smaller TS be used
%         e.g. (largest time duration)/100.
%
%         EXAMPLE: CONVPLOT('sin(pi*t)','tri(t)',[0 1],[-1 1])

if nargin==0,
 help convplot
 disp('Strike a key to see results of the example');
 pause;
 convplot('sin(pi*t)','tri(t)',[0 1],[-1 1]);
 return
end

if nargin<5,
 dx=abs(diff(tx));
 dy=abs(diff(ty));
 tf=max([dx dy]);
 ts=tf/50;
end

%vx=matver;
%if vx<4,
% eval('cnvpl35n(xs,ys,tx,ty,ts)');
%else
 eval('cnvplt4n(xs,ys,tx,ty,ts)');
%end

